--- ocaml-4.02.3.old/configure	2015-05-12 16:46:37.000000000 +0200
+++ ocaml-4.02.3/configure	2015-10-07 09:50:14.992000000 +0200
@@ -47,6 +47,8 @@
 no_naked_pointers=false
 TOOLPREF=""
 with_cfi=true
+arch64=false
+big_endian=1
 
 # Try to turn internationalization off, can cause config.guess to malfunction!
 unset LANG
@@ -154,6 +156,10 @@
         no_naked_pointers=true;;
     -no-cfi|--no-cfi)
         with_cfi=false;;
+    -arch64|--arch64)
+        arch64=true;;
+    -big-endian|--big-endian)
+        big_endian=0;;
     *) if echo "$1" | grep -q -e '^--\?[a-zA-Z0-9-]\+='; then
          err "configure expects arguments of the form '-prefix /foo/bar'," \
              "not '-prefix=/foo/bar' (note the '=')."
@@ -531,20 +537,13 @@
   esac
 else
   # For cross-compilation, runtest always fails: add special handling.
-  case "$target" in
-    i686-*-mingw*) inf "OK, this is a regular 32 bit architecture."
-                   echo "#undef ARCH_SIXTYFOUR" >> m.h
-                   set 4 4 4 2 8
-                   arch64=false;;
-    x86_64-*-mingw*) inf "Wow! A 64 bit architecture!"
-                     echo "#define ARCH_SIXTYFOUR" >> m.h
-                     set 4 4 8 2 8
-                     arch64=true;;
-    *) err "Since datatype sizes cannot be guessed when cross-compiling,\n" \
-           "a hardcoded list is used but your architecture isn't known yet.\n" \
-           "You need to determine the sizes yourself.\n" \
-           "Please submit a bug report in order to expand the list." ;;
-  esac
+  if $arch64; then
+    echo "#define ARCH_SIXTYFOUR" >> m.h
+    set 4 4 8 2 8
+  else
+    echo "#undef ARCH_SIXTYFOUR" >> m.h
+    set 4 4 4 2 8
+  fi
 fi
 
 if test $1 != 4 && test $2 != 4 && test $4 != 4; then
@@ -567,8 +566,11 @@
 
 # Determine endianness
 
-sh ./runtest endian.c
-case $? in
+if ! $cross_compiler; then
+  sh ./runtest endian.c
+  big_endian=$?
+fi
+case $big_endian in
   0) inf "This is a big-endian architecture."
      echo "#define ARCH_BIG_ENDIAN" >> m.h;;
   1) inf "This is a little-endian architecture."
